///
/// @file   coworker_sys.c
/// @author tanwen
/// @date   2012-5-28
///

#include <ntifs.h>
#include <wdmsec.h>

PDEVICE_OBJECT g_cdo = NULL;

const GUID  CWK_GUID_CLASS_MYCDO =
{0x17a0d1e0L, 0x3249, 0x12e1, {0x92,0x16, 0x45, 0x1a, 0x21, 0x30, 0x29, 0x06}};

#define CWK_CDO_SYB_NAME    L"\\??\\slbkcdo_3948d33e"

// Ӧòһַ
#define  CWK_DVC_SEND_STR \
	(ULONG)CTL_CODE( \
	FILE_DEVICE_UNKNOWN, \
	0x911,METHOD_BUFFERED, \
	FILE_WRITE_DATA)

// ȡһַ
#define  CWK_DVC_RECV_STR \
	(ULONG)CTL_CODE( \
	FILE_DEVICE_UNKNOWN, \
	0x912,METHOD_BUFFERED, \
	FILE_READ_DATA)

// һַ
#define CWK_STR_LEN_MAX 512
typedef struct {
    LIST_ENTRY list_entry;
    char buf[CWK_STR_LEN_MAX];
} CWK_STR_NODE;

// һ֤İȫ
KSPIN_LOCK g_cwk_lock;
// һ¼ʶǷַȡ
KEVENT  g_cwk_event;
// иͷ
LIST_ENTRY g_cwk_str_list;

#define MEM_TAG 'cwkr'

// ڴ沢ʼһڵ
CWK_STR_NODE *cwkMallocStrNode()
{
    CWK_STR_NODE *ret = ExAllocatePoolWithTag(
        NonPagedPool, sizeof(CWK_STR_NODE), MEM_TAG);
    if(ret == NULL)
        return NULL;
    return ret;
}

void cwkUnload(PDRIVER_OBJECT driver)
{
	UNICODE_STRING cdo_syb = RTL_CONSTANT_STRING(CWK_CDO_SYB_NAME);
    CWK_STR_NODE *str_node;
    ASSERT(g_cdo != NULL);
   	IoDeleteSymbolicLink(&cdo_syb);
    IoDeleteDevice(g_cdo);

    // ı̬ȣͷŷںڴ档
    while(TRUE)
    {
        str_node = (CWK_STR_NODE *)ExInterlockedRemoveHeadList(
            &g_cwk_str_list, &g_cwk_lock);
        // str_node = RemoveHeadList(&g_cwk_str_list);
        if(str_node != NULL)
            ExFreePool(str_node);
        else
            break;
    };
}

NTSTATUS cwkDispatch(		
			      IN PDEVICE_OBJECT dev,
			      IN PIRP irp)
{
    PIO_STACK_LOCATION  irpsp = IoGetCurrentIrpStackLocation(irp);
    NTSTATUS status = STATUS_SUCCESS;
    ULONG ret_len = 0;
    while(dev == g_cdo) 
    {
        // Ƿg_cdoģǾͷǳˡ
        // Ϊֻɹһ豸Կֱ
        // ʧܡ
	    if(irpsp->MajorFunction == IRP_MJ_CREATE || irpsp->MajorFunction == IRP_MJ_CLOSE)
	    {
            // ɺ͹رһɼ򵥵طسɹͿ
            // ˡۺʱ򿪺͹رնԳɹ
            break;
	    }
    	
        if(irpsp->MajorFunction == IRP_MJ_DEVICE_CONTROL)
	    {
		    // DeviceIoControl
            PVOID buffer = irp->AssociatedIrp.SystemBuffer;  
            ULONG inlen = irpsp->Parameters.DeviceIoControl.InputBufferLength;
            ULONG outlen = irpsp->Parameters.DeviceIoControl.OutputBufferLength;
		    ULONG len;
            CWK_STR_NODE *str_node;
		    switch(irpsp->Parameters.DeviceIoControl.IoControlCode)
		    {
            case CWK_DVC_SEND_STR:

                ASSERT(buffer != NULL);
                ASSERT(outlen == 0);

                // ȫı̬֮һ:뻺ĳȶڳȳԤڵģ
                // Ϸش
                if(inlen > CWK_STR_LEN_MAX)
                {
                    status = STATUS_INVALID_PARAMETER;
                    break;                    
                }

                // ȫıַ̬֮ĳȣҪʹstrlen!ʹ
                // strlen,һ߹ûнַᵼں
                // ʷǷڴռ
                DbgPrint("strnlen = %d\r\n", strnlen((char *)buffer, inlen));
                if(strnlen((char *)buffer, inlen) == inlen)
                {
                    // ַռ˻мûн̷ش
                    status = STATUS_INVALID_PARAMETER;
                    break;                    
                }

                // ڿΪ뻺ǰȫҲġڵ㡣
                str_node = cwkMallocStrNode();
                if(str_node == NULL)
                {
                    // 䲻ռˣԴĴ
                    status = STATUS_INSUFFICIENT_RESOURCES;
                    break;
                }

                // ǰѾ˻еַȷȺʶҺн
                // ʲôַ԰ȫԶԲǳҪ
                strncpy(str_node->buf,(char *)buffer, CWK_STR_LEN_MAX); 
                // 뵽ĩβ֤ȫԡ
                ExInterlockedInsertTailList(&g_cwk_str_list, (PLIST_ENTRY)str_node, &g_cwk_lock);
                // InsertTailList(&g_cwk_str_list, (PLIST_ENTRY)str_node);
                // ӡ
                // DbgPrint((char *)buffer);
                // ôھͿΪѾɹΪոѾһ
                // ô¼ѾԪˡ
                KeSetEvent(&g_cwk_event, 0, TRUE);
                break;
            case CWK_DVC_RECV_STR:
                ASSERT(buffer != NULL);
                ASSERT(inlen == 0);
                // ӦҪַԴˣȫҪҪ㹻
                if(outlen < CWK_STR_LEN_MAX)
                {
                    status = STATUS_INVALID_PARAMETER;
                    break;                    
                }
                while(1) 
                {
                    // 뵽ĩβ֤ȫԡ
                    str_node = (CWK_STR_NODE *)ExInterlockedRemoveHeadList(&g_cwk_str_list, &g_cwk_lock);
                    // str_node = RemoveHeadList(&g_cwk_str_list);
                    if(str_node != NULL)
                    {
                        // £ȡַǾͿСȻ
                        // ͷ˳ɹ
                        strncpy((char *)buffer, str_node->buf, CWK_STR_LEN_MAX);
                        ret_len = strnlen(str_node->buf, CWK_STR_LEN_MAX) + 1;
                        ExFreePool(str_node);
                        break;
                    }
                    else
                    {
                        // ںϷҪڻΪյ£ȴ¼
                        // Ҳ˵ûַͣȴ
                        // ӦóҲᱻסDeviceIoControlǲ᷵
                        // ġһоͻ᷵ء֪ͨӦá
                        KeWaitForSingleObject(&g_cwk_event,Executive,KernelMode,0,0);
                    }
                }
                break;
            default:
                // ǲܵδ֪һɷطǷ
                status = STATUS_INVALID_PARAMETER;
                break;
            }
        }
        break;
    }
    // ؽ
	irp->IoStatus.Information = ret_len;
	irp->IoStatus.Status = status;
	IoCompleteRequest(irp,IO_NO_INCREMENT);
	return status;
}


NTSTATUS DriverEntry(PDRIVER_OBJECT driver,PUNICODE_STRING reg_path)
{
	NTSTATUS status;
	ULONG i;
    UCHAR mem[256] = { 0 };

	// һ豸Ȼɷӡ
	UNICODE_STRING sddl = RTL_CONSTANT_STRING(L"D:P(A;;GA;;;WD)");
	UNICODE_STRING cdo_name = RTL_CONSTANT_STRING(L"\\Device\\cwk_3948d33e");
	UNICODE_STRING cdo_syb = RTL_CONSTANT_STRING(CWK_CDO_SYB_NAME);

    KdBreakPoint();

	// һ豸
	status = IoCreateDeviceSecure(
		driver,
		0,&cdo_name,
		FILE_DEVICE_UNKNOWN,
		FILE_DEVICE_SECURE_OPEN,
		FALSE,&sddl,
		(LPCGUID)&CWK_GUID_CLASS_MYCDO,
		&g_cdo);
	if(!NT_SUCCESS(status))
		return status;

	// ɷ.
	IoDeleteSymbolicLink(&cdo_syb);
	status = IoCreateSymbolicLink(&cdo_syb,&cdo_name);
	if(!NT_SUCCESS(status))
	{
		IoDeleteDevice(g_cdo);
		return status;
	}

    // ʼ¼ͷ
    KeInitializeEvent(&g_cwk_event,SynchronizationEvent,TRUE); 
    KeInitializeSpinLock(&g_cwk_lock);
    InitializeListHead(&g_cwk_str_list);

	// еķַóһġ
	for(i=0;i<IRP_MJ_MAXIMUM_FUNCTION;i++)
	{
		driver->MajorFunction[i] = cwkDispatch;
	}

	// ֶ֧̬жء
    driver->DriverUnload = cwkUnload;
	// 豸ĳʼǡ
	g_cdo->Flags &= ~DO_DEVICE_INITIALIZING;
	return STATUS_SUCCESS;
}
