///
/// @file         cf_list.c
/// @author    crazy_chu
/// @date       2009-1-29
/// @brief      ʵһڼܴŵļ
///                עֻ֧WindowsXPµFastFatļϵͳ
///
/// 
/// Ϊʾ롣δ꾡ԣ֤ɿԡ߶
/// κʹô˴뵼µֱӺͼʧΡ
/// 
/// ȨЭ
/// ڹcrypt_file.ǳwowocockΪ
/// Windowsں˱Ϣȫдļ͸
/// ʾ֧̽WindowsXP£FastFatļϵͳ¼
/// ļܡδɱļ
/// ȫȨΪ߱ѧϰĶʹ
/// áδλȨֱӸơ߻ڴ˴
/// ޸ġô˴ṩȫּ߲ҵ
/// ĻΪΥ߱
/// ߺͻȡ⳥֮ȨĶ˴룬ԶΪ
/// ȨЭ顣粻ܴЭߣ벻ҪĶ˴롣
///

#include <ntifs.h>
#include "cf_file_irp.h"
#include "fat_headers/fat.h"
#include "fat_headers/nodetype.h"
#include "fat_headers/fatstruc.h"

#define CF_MEM_TAG 'cfls'
#define CF_FILE_HEADER_SIZE (1024*4)

typedef struct {
    LIST_ENTRY list_entry;
    FCB *fcb;
} CF_NODE,*PCF_NODE;

static LIST_ENTRY s_cf_list;
static KSPIN_LOCK s_cf_list_lock;
static KIRQL s_cf_list_lock_irql;
static BOOLEAN s_cf_list_inited = FALSE;
BOOLEAN cfListInited()
{
    return s_cf_list_inited;
}
 
void cfListLock()
{
    ASSERT(s_cf_list_inited);
    KeAcquireSpinLock(&s_cf_list_lock,&s_cf_list_lock_irql);
}

void cfListUnlock()
{
    ASSERT(s_cf_list_inited);
    KeReleaseSpinLock(&s_cf_list_lock,s_cf_list_lock_irql);
}

void cfListInit()
{
    InitializeListHead(&s_cf_list);
    KeInitializeSpinLock(&s_cf_list_lock);
    s_cf_list_inited = TRUE;
}

// һļжǷڼСû
BOOLEAN cfIsFileCrypting(PFILE_OBJECT file)
{
    PLIST_ENTRY p;
    PCF_NODE node;
   for(p = s_cf_list.Flink; p != &s_cf_list; p = p->Flink)
    {
	    node = (PCF_NODE)p;
        if(node->fcb == file->FsContext)
        {
            //KdPrint(("cfIsFileCrypting: file %wZ is crypting. fcb = %x \r\n",&file->FileName,file->FsContext));
            return TRUE;
        }
    } 
    return FALSE;
}

// ׷һʹõĻļмֻ֤һ
// ظ롣
BOOLEAN cfFileCryptAppendLk(PFILE_OBJECT file)
{
    // ȷռ
    PCF_NODE node = (PCF_NODE)
        ExAllocatePoolWithTag(NonPagedPool,sizeof(CF_NODE),CF_MEM_TAG);
    node->fcb = (PFCB)file->FsContext;

    cfFileCacheClear(file);

    // ңѾˣһĴֱӱɡ
    cfListLock();
    if(cfIsFileCrypting(file))
    {
        ASSERT(FALSE);
        return TRUE;
    }
    else if(node->fcb->UncleanCount > 1)
    {
        // Ҫɹļ룬ҪһFCB->UncleanCount <= 1.
        // Ļ˵ûļĻһ
        // ̴ͨʱܼܡؾܾ򿪡
        cfListUnlock();
        // ͷŵ
        ExFreePool(node);
        return FALSE;
    }

    // Ļ뵽
    InsertHeadList(&s_cf_list, (PLIST_ENTRY)node);
    cfListUnlock();

    //cfFileCacheClear(file);
    return TRUE;
}


// ļclean upʱô˺鷢
// FileObject->FsContextб
BOOLEAN cfCryptFileCleanupComplete(PFILE_OBJECT file)
{
    PLIST_ENTRY p;
    PCF_NODE node;
    FCB *fcb = (FCB *)file->FsContext;

    KdPrint(("cfCryptFileCleanupComplete: file name = %wZ, fcb->UncleanCount = %d\r\n",
        &file->FileName,fcb->UncleanCount));

    // ļ塣ȻٴƳĻ建
    // ʱдͲˡ
    if(fcb->UncleanCount <= 1 || (fcb->FcbState & FCB_STATE_DELETE_ON_CLOSE) )
        cfFileCacheClear(file);
    else
        return FALSE;

    cfListLock();
   for(p = s_cf_list.Flink; p != &s_cf_list; p = p->Flink)
   {
	    node = (PCF_NODE)p;
        if(node->fcb == file->FsContext && 
            (node->fcb->UncleanCount == 0 ||
            (fcb->FcbState & FCB_STATE_DELETE_ON_CLOSE)))
        {
            // Ƴ
            RemoveEntryList((PLIST_ENTRY)node);
            cfListUnlock();
            //  ͷڴ档
            ExFreePool(node);
            return TRUE;
        }
    } 
    cfListUnlock();
   return FALSE;
}
